local addonInfo, privateVars = ...

nkQuestTracker.layout = {
	elementColor = { 0.153, 0.314, 0.490, 1},
	labelColor = { 1, 1, 1, 1 }
}

function nkQuestTracker.Config ()

	local name = 'nkQuestTracker.Config'

	local config = EnKai.uiCreateFrame("nkWindowMetro", name, privateVars.uiElements.configContext)
	local tabPane = EnKai.uiCreateFrame("nkTabPaneMetro", name .. ".tabPane", config:GetContent())
	
	local paneTabSettings = nkQuestTracker.ConfigTabSettings(tabPane)

  config:SetPoint("CENTER", UIParent, "CENTER")
  config:SetWidth(650)
  config:SetHeight(650) 
  config:SetTitle(addonInfo.toc.Name)
  config:SetCloseable(true)
  
  local EnKaiLogo = EnKai.uiCreateFrame("nkTexture", name .. ".EnKaiLogo", config)
  EnKaiLogo:SetTextureAsync(EnKai.art.GetThemeLogo()[1],EnKai.art.GetThemeLogo()[2])
  EnKaiLogo:SetPoint("BOTTOMLEFT", config:GetContent(), "BOTTOMLEFT", 10, -5)
  EnKaiLogo:SetWidth(125)
  EnKaiLogo:SetHeight(33)
  		
  tabPane:SetBorder(false)
  tabPane:SetPoint("TOPLEFT", config:GetContent(), "TOPLEFT", 10, 10)
  tabPane:SetPoint("BOTTOMRIGHT", config:GetContent(), "BOTTOMRIGHT", -10, -50)
  tabPane:SetLayer(1)
  
	tabPane:AddPane( { label = privateVars.langTexts.tabHeaderSettings, frame = paneTabSettings, initFunc = function() paneTabSettings:build() end}, true)
	
	local closeButton = EnKai.uiCreateFrame("nkButtonMetro", name .. ".closeButton", config:GetContent())
  
  closeButton:SetPoint("BOTTOMRIGHT", config:GetContent(), "BOTTOMRIGHT", -10, -10)
  closeButton:SetText(privateVars.langTexts.btClose)
  closeButton:SetIcon("nkQuestTracker", "gfx/iconClose.png")
  closeButton:SetScale(.8)
  closeButton:SetLayer(9)
  
  Command.Event.Attach(EnKai.events[name .. ".closeButton"].Clicked, function (_, newValue)
    Command.Event.Detach(Event.Tooltip, nil, "nkZoo.Event.Tooltip")
    privateVars.scan = false
    config:SetVisible(false) 
  end, name .. ".closeButton.Clicked")
	
	local pasteButton = EnKai.uiCreateFrame("nkButtonMetro", name .. ".pasteButton", config:GetContent())
	pasteButton:SetPoint("CENTERRIGHT", closeButton, "CENTERLEFT", -5, 0)
  pasteButton:SetText(privateVars.langTexts.btPaste)
  pasteButton:SetIcon("nkQuestTracker", "gfx/iconPaste.png")
  pasteButton:SetWidth(200)
  pasteButton:SetScale(.8)  
  pasteButton:SetLayer(9)
  
  Command.Event.Attach(EnKai.events[name .. ".pasteButton"].Clicked, function (_, newValue)
    nkQuestTrackerSetup = nkQuestTrackerGlobal
    privateVars.internal.messageDialog (privateVars.langTexts.pasteMessage)
	end, name .. ".pasteButton.Clicked")	
	
	local copyButton = EnKai.uiCreateFrame("nkButtonMetro", name .. ".copyButton", config:GetContent())
	copyButton:SetPoint("CENTERRIGHT", pasteButton, "CENTERLEFT", -5, 0)
	copyButton:SetText(privateVars.langTexts.btCopy)
	copyButton:SetIcon("nkQuestTracker", "gfx/iconCopy.png")
  copyButton:SetLayer(9)
  copyButton:SetWidth(200)
	copyButton:SetScale(.8)
		
	 Command.Event.Attach(EnKai.events[name .. ".copyButton"].Clicked, function (_, newValue)
		nkQuestTrackerGlobal = nkQuestTrackerSetup
		privateVars.internal.messageDialog (privateVars.langTexts.copyMessage)
	end, name .. '.copyButton.Left.Click')
				
	local versionText = UI.CreateFrame("Text", name .. ".versionText", tabPane)
	versionText:SetFontSize(11)
	versionText:SetText(string.format(privateVars.langTexts.txtVersion, addonInfo.toc.Version))
	versionText:SetPoint("BOTTOMLEFT", config:GetContent(), "BOTTOMLEFT", 10, -10)
	versionText:SetLayer(99)	
	
	local versionText = EnKai.uiCreateFrame("nkText", name .. ".versionText", config)
  versionText:SetFontSize(11)
  versionText:SetText(string.format(privateVars.langTexts.txtVersion, addonInfo.toc.Version))
  versionText:SetPoint("BOTTOMRIGHT", tabPane, "BOTTOMRIGHT", -5, -5)
  versionText:SetLayer(98)
	
	config:SetVisible(true)
	
	return config
	
end